/**
 * EasyBeans
 * Copyright (C) 2006 Bull S.A.S.
 * Contact: easybeans@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: EJBContext.java 126 2006-03-06 17:51:00Z benoitf $
 * --------------------------------------------------------------------------
 */

package javax.ejb;

import java.security.Identity;
import java.security.Principal;
import java.util.Properties;

import javax.transaction.UserTransaction;

/**
 * @see <a href="http://www.jcp.org/en/jsr/detail?id=220">EJB 3.0 specification</a>
 * @author Florent Benoit
 */
public interface EJBContext {

    EJBHome getEJBHome() throws IllegalStateException;

    EJBLocalHome getEJBLocalHome() throws IllegalStateException;

    @Deprecated
    Properties getEnvironment();

    @Deprecated
    Identity getCallerIdentity();

    Principal getCallerPrincipal();


    @Deprecated
    boolean isCallerInRole(final Identity role);


    boolean isCallerInRole(final String roleName);


    UserTransaction getUserTransaction() throws IllegalStateException;


    void setRollbackOnly() throws IllegalStateException;


    boolean getRollbackOnly() throws IllegalStateException ;


    TimerService getTimerService() throws IllegalStateException;

    Object lookup(String name);
}
