/**
 * EasyBeans
 * Copyright (C) 2006 Bull S.A.S.
 * Contact: easybeans@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: IDeployer.java 9 2006-02-19 18:53:32Z benoitf $
 * --------------------------------------------------------------------------
 */

package org.objectweb.easybeans.deployer;

/**
 * Interface allowing to deploys some files to this EJB3 container.
 * @author Florent Benoit
 */
public interface IDeployer {

    /**
     * Deploy a file on the EJB3 container.
     * @param typeparam type of the file (EJB, WAR, EAR, RAR, CAR) (ModuleType
     *        of JSR88)
     * @param bfile bytes array of the file
     * @param filename basename of the file to be deployed
     * @return the path of the deployed file
     */
    String deployFile(Integer typeparam, java.lang.Byte[] bfile, String filename);

    /**
     * Deploy an application packaged in a EAR file.
     * @param fileName the name of the file to deploy
     */
    void deployEar(String fileName);

    /**
     * Deploy an EJB packaged in a JAR file.
     * @param fileName the name of the file to deploy
     */
    void deployEjbJar(String fileName);
}
